/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_CONVERTROCKTOGPUPASS
#define GEN_PASS_DECL_FP8EXTTOTABLESPASS
#define GEN_PASS_DECL_GPUTOMIGRAPHXPASS
#define GEN_PASS_DECL_MIGRAPHXTOTOSAPASS
#define GEN_PASS_DECL_TOSATOROCKPASS
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ConvertRockToGPUPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_CONVERTROCKTOGPUPASS
std::unique_ptr<::mlir::Pass> createConvertRockToGPUPass();
#undef GEN_PASS_DECL_CONVERTROCKTOGPUPASS
#endif // GEN_PASS_DECL_CONVERTROCKTOGPUPASS
#ifdef GEN_PASS_DEF_CONVERTROCKTOGPUPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createConvertRockToGPUPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class ConvertRockToGPUPassBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = ConvertRockToGPUPassBase;

  ConvertRockToGPUPassBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertRockToGPUPassBase(const ConvertRockToGPUPassBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("convert-rock-to-gpu");
  }
  ::llvm::StringRef getArgument() const override { return "convert-rock-to-gpu"; }

  ::llvm::StringRef getDescription() const override { return "Lower the operations from the Rock dialect into the GPU dialect"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertRockToGPUPass");
  }
  ::llvm::StringRef getName() const override { return "ConvertRockToGPUPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<amdgpu::AMDGPUDialect>();

  registry.insert<cf::ControlFlowDialect>();

  registry.insert<DLTIDialect>();

  registry.insert<func::FuncDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<LLVM::LLVMDialect>();

  registry.insert<memref::MemRefDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertRockToGPUPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createConvertRockToGPUPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createConvertRockToGPUPass() {
  return impl::createConvertRockToGPUPass();
}
#undef GEN_PASS_DEF_CONVERTROCKTOGPUPASS
#endif // GEN_PASS_DEF_CONVERTROCKTOGPUPASS

//===----------------------------------------------------------------------===//
// Fp8ExtToTablesPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_FP8EXTTOTABLESPASS
std::unique_ptr<::mlir::Pass> createFp8ExtToTablesPass();
#undef GEN_PASS_DECL_FP8EXTTOTABLESPASS
#endif // GEN_PASS_DECL_FP8EXTTOTABLESPASS
#ifdef GEN_PASS_DEF_FP8EXTTOTABLESPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createFp8ExtToTablesPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class Fp8ExtToTablesPassBase : public ::mlir::OperationPass<> {
public:
  using Base = Fp8ExtToTablesPassBase;

  Fp8ExtToTablesPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  Fp8ExtToTablesPassBase(const Fp8ExtToTablesPassBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("fp8-ext-to-tables");
  }
  ::llvm::StringRef getArgument() const override { return "fp8-ext-to-tables"; }

  ::llvm::StringRef getDescription() const override { return "Lower arith.extf on fp8 types to table lookup"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Fp8ExtToTablesPass");
  }
  ::llvm::StringRef getName() const override { return "Fp8ExtToTablesPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arith::ArithDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<vector::VectorDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(Fp8ExtToTablesPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createFp8ExtToTablesPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createFp8ExtToTablesPass() {
  return impl::createFp8ExtToTablesPass();
}
#undef GEN_PASS_DEF_FP8EXTTOTABLESPASS
#endif // GEN_PASS_DEF_FP8EXTTOTABLESPASS

//===----------------------------------------------------------------------===//
// GPUToMIGraphXPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_GPUTOMIGRAPHXPASS
std::unique_ptr<::mlir::Pass> createGPUToMIGraphXPass();
#undef GEN_PASS_DECL_GPUTOMIGRAPHXPASS
#endif // GEN_PASS_DECL_GPUTOMIGRAPHXPASS
#ifdef GEN_PASS_DEF_GPUTOMIGRAPHXPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createGPUToMIGraphXPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class GPUToMIGraphXPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = GPUToMIGraphXPassBase;

  GPUToMIGraphXPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  GPUToMIGraphXPassBase(const GPUToMIGraphXPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("gpu-to-migraphx");
  }
  ::llvm::StringRef getArgument() const override { return "gpu-to-migraphx"; }

  ::llvm::StringRef getDescription() const override { return "Lower fused gpu launch to MIGraphX code object"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GPUToMIGraphXPass");
  }
  ::llvm::StringRef getName() const override { return "GPUToMIGraphXPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<migraphx::MIGraphXDialect>();

  registry.insert<func::FuncDialect>();

  registry.insert<gpu::GPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GPUToMIGraphXPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createGPUToMIGraphXPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createGPUToMIGraphXPass() {
  return impl::createGPUToMIGraphXPass();
}
#undef GEN_PASS_DEF_GPUTOMIGRAPHXPASS
#endif // GEN_PASS_DEF_GPUTOMIGRAPHXPASS

//===----------------------------------------------------------------------===//
// MIGraphXToTosaPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_MIGRAPHXTOTOSAPASS
std::unique_ptr<::mlir::Pass> createMIGraphXToTosaPass();
#undef GEN_PASS_DECL_MIGRAPHXTOTOSAPASS
#endif // GEN_PASS_DECL_MIGRAPHXTOTOSAPASS
#ifdef GEN_PASS_DEF_MIGRAPHXTOTOSAPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createMIGraphXToTosaPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class MIGraphXToTosaPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = MIGraphXToTosaPassBase;

  MIGraphXToTosaPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  MIGraphXToTosaPassBase(const MIGraphXToTosaPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("migraphx-to-tosa");
  }
  ::llvm::StringRef getArgument() const override { return "migraphx-to-tosa"; }

  ::llvm::StringRef getDescription() const override { return "Lower MIGraphX to TOSA"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MIGraphXToTosaPass");
  }
  ::llvm::StringRef getName() const override { return "MIGraphXToTosaPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<func::FuncDialect>();

  registry.insert<tosa::TosaDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MIGraphXToTosaPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createMIGraphXToTosaPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createMIGraphXToTosaPass() {
  return impl::createMIGraphXToTosaPass();
}
#undef GEN_PASS_DEF_MIGRAPHXTOTOSAPASS
#endif // GEN_PASS_DEF_MIGRAPHXTOTOSAPASS

//===----------------------------------------------------------------------===//
// TosaToRockPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_TOSATOROCKPASS
std::unique_ptr<::mlir::Pass> createTosaToRockPass();
#undef GEN_PASS_DECL_TOSATOROCKPASS
#endif // GEN_PASS_DECL_TOSATOROCKPASS
#ifdef GEN_PASS_DEF_TOSATOROCKPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createTosaToRockPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class TosaToRockPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = TosaToRockPassBase;

  TosaToRockPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  TosaToRockPassBase(const TosaToRockPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tosa-to-rock");
  }
  ::llvm::StringRef getArgument() const override { return "tosa-to-rock"; }

  ::llvm::StringRef getDescription() const override { return "Lower TOSA to Rock"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TosaToRockPass");
  }
  ::llvm::StringRef getName() const override { return "TosaToRockPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<bufferization::BufferizationDialect>();

  registry.insert<func::FuncDialect>();

  registry.insert<rock::RockDialect>();

  registry.insert<tensor::TensorDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TosaToRockPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createTosaToRockPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createTosaToRockPass() {
  return impl::createTosaToRockPass();
}
#undef GEN_PASS_DEF_TOSATOROCKPASS
#endif // GEN_PASS_DEF_TOSATOROCKPASS
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ConvertRockToGPUPass Registration
//===----------------------------------------------------------------------===//

inline void registerConvertRockToGPUPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createConvertRockToGPUPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerConvertRockToGPUPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createConvertRockToGPUPass();
  });
}

//===----------------------------------------------------------------------===//
// Fp8ExtToTablesPass Registration
//===----------------------------------------------------------------------===//

inline void registerFp8ExtToTablesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createFp8ExtToTablesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerFp8ExtToTablesPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createFp8ExtToTablesPass();
  });
}

//===----------------------------------------------------------------------===//
// GPUToMIGraphXPass Registration
//===----------------------------------------------------------------------===//

inline void registerGPUToMIGraphXPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createGPUToMIGraphXPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerGPUToMIGraphXPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createGPUToMIGraphXPass();
  });
}

//===----------------------------------------------------------------------===//
// MIGraphXToTosaPass Registration
//===----------------------------------------------------------------------===//

inline void registerMIGraphXToTosaPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createMIGraphXToTosaPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerMIGraphXToTosaPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createMIGraphXToTosaPass();
  });
}

//===----------------------------------------------------------------------===//
// TosaToRockPass Registration
//===----------------------------------------------------------------------===//

inline void registerTosaToRockPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createTosaToRockPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerTosaToRockPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createTosaToRockPass();
  });
}

//===----------------------------------------------------------------------===//
// RocMLIRConversion Registration
//===----------------------------------------------------------------------===//

inline void registerRocMLIRConversionPasses() {
  registerConvertRockToGPUPass();
  registerFp8ExtToTablesPass();
  registerGPUToMIGraphXPass();
  registerMIGraphXToTosaPass();
  registerTosaToRockPass();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ConvertRockToGPUPassBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = ConvertRockToGPUPassBase;

  ConvertRockToGPUPassBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertRockToGPUPassBase(const ConvertRockToGPUPassBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("convert-rock-to-gpu");
  }
  ::llvm::StringRef getArgument() const override { return "convert-rock-to-gpu"; }

  ::llvm::StringRef getDescription() const override { return "Lower the operations from the Rock dialect into the GPU dialect"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertRockToGPUPass");
  }
  ::llvm::StringRef getName() const override { return "ConvertRockToGPUPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<amdgpu::AMDGPUDialect>();

  registry.insert<cf::ControlFlowDialect>();

  registry.insert<DLTIDialect>();

  registry.insert<func::FuncDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<LLVM::LLVMDialect>();

  registry.insert<memref::MemRefDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertRockToGPUPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class Fp8ExtToTablesPassBase : public ::mlir::OperationPass<> {
public:
  using Base = Fp8ExtToTablesPassBase;

  Fp8ExtToTablesPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  Fp8ExtToTablesPassBase(const Fp8ExtToTablesPassBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("fp8-ext-to-tables");
  }
  ::llvm::StringRef getArgument() const override { return "fp8-ext-to-tables"; }

  ::llvm::StringRef getDescription() const override { return "Lower arith.extf on fp8 types to table lookup"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Fp8ExtToTablesPass");
  }
  ::llvm::StringRef getName() const override { return "Fp8ExtToTablesPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<arith::ArithDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<vector::VectorDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(Fp8ExtToTablesPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class GPUToMIGraphXPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = GPUToMIGraphXPassBase;

  GPUToMIGraphXPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  GPUToMIGraphXPassBase(const GPUToMIGraphXPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("gpu-to-migraphx");
  }
  ::llvm::StringRef getArgument() const override { return "gpu-to-migraphx"; }

  ::llvm::StringRef getDescription() const override { return "Lower fused gpu launch to MIGraphX code object"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GPUToMIGraphXPass");
  }
  ::llvm::StringRef getName() const override { return "GPUToMIGraphXPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<migraphx::MIGraphXDialect>();

  registry.insert<func::FuncDialect>();

  registry.insert<gpu::GPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GPUToMIGraphXPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class MIGraphXToTosaPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = MIGraphXToTosaPassBase;

  MIGraphXToTosaPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  MIGraphXToTosaPassBase(const MIGraphXToTosaPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("migraphx-to-tosa");
  }
  ::llvm::StringRef getArgument() const override { return "migraphx-to-tosa"; }

  ::llvm::StringRef getDescription() const override { return "Lower MIGraphX to TOSA"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MIGraphXToTosaPass");
  }
  ::llvm::StringRef getName() const override { return "MIGraphXToTosaPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<func::FuncDialect>();

  registry.insert<tosa::TosaDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MIGraphXToTosaPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class TosaToRockPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = TosaToRockPassBase;

  TosaToRockPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  TosaToRockPassBase(const TosaToRockPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tosa-to-rock");
  }
  ::llvm::StringRef getArgument() const override { return "tosa-to-rock"; }

  ::llvm::StringRef getDescription() const override { return "Lower TOSA to Rock"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TosaToRockPass");
  }
  ::llvm::StringRef getName() const override { return "TosaToRockPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<bufferization::BufferizationDialect>();

  registry.insert<func::FuncDialect>();

  registry.insert<rock::RockDialect>();

  registry.insert<tensor::TensorDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TosaToRockPassBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
