/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AttrDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_ATTRDEF_CLASSES
#undef GET_ATTRDEF_CLASSES


namespace mlir {
class AsmParser;
class AsmPrinter;
} // namespace mlir
namespace mlir {
namespace rock {
class ReduceMethodAttr;
class GemmFeaturesAttr;
class GeneralGemmParamsAttr;
class PrefillAttr;
class TransformAttr;
class TransformMapAttr;
class WmmaGemmParamsAttr;
class XdlopsGemmParamsAttr;
class StoreMethodAttr;
namespace detail {
struct ReduceMethodAttrStorage;
} // namespace detail
class ReduceMethodAttr : public ::mlir::Attribute::AttrBase<ReduceMethodAttr, ::mlir::Attribute, detail::ReduceMethodAttrStorage> {
public:
  using Base::Base;
  static ReduceMethodAttr get(::mlir::MLIRContext *context, ::mlir::rock::ReduceMethod value);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"ReduceMethod"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::rock::ReduceMethod getValue() const;
};
namespace detail {
struct GemmFeaturesAttrStorage;
} // namespace detail
class GemmFeaturesAttr : public ::mlir::Attribute::AttrBase<GemmFeaturesAttr, ::mlir::Attribute, detail::GemmFeaturesAttrStorage> {
public:
  using Base::Base;
  static GemmFeaturesAttr get(::mlir::MLIRContext *context, ::mlir::rock::GemmFeatures value);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"GemmFeatures"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::rock::GemmFeatures getValue() const;
};
namespace detail {
struct GeneralGemmParamsAttrStorage;
} // namespace detail
class GeneralGemmParamsAttr : public ::mlir::Attribute::AttrBase<GeneralGemmParamsAttr, ::mlir::Attribute, detail::GeneralGemmParamsAttrStorage, ::mlir::rock::RockTuningParamAttrInterface::Trait> {
public:
  using Base::Base;
  void getPerfConfigStr(::llvm::SmallVectorImpl<char> &perfStr) {
    (Twine(getBlockSize()) + ","
    + Twine(getMPerBlock()) + ","
    + Twine(getNPerBlock()) + ","
    + Twine(getKPerBlock()) + ","
    + Twine(getMPerThread()) + ","
    + Twine(getNPerThread())).toVector(perfStr);
  }
  bool getForceUnroll() { return true; }
  static GeneralGemmParamsAttr get(::mlir::MLIRContext *context, uint32_t blockSize, int64_t kPerBlock, int64_t mPerBlock, int64_t nPerBlock, int64_t kPerThread, int64_t mPerThread, int64_t nPerThread, int64_t kpack);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"general_gemm_params"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  uint32_t getBlockSize() const;
  int64_t getKPerBlock() const;
  int64_t getMPerBlock() const;
  int64_t getNPerBlock() const;
  int64_t getKPerThread() const;
  int64_t getMPerThread() const;
  int64_t getNPerThread() const;
  int64_t getKpack() const;
};
class PrefillAttr : public ::mlir::Attribute::AttrBase<PrefillAttr, ::mlir::Attribute, ::mlir::AttributeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"rock.prefill"};
  }

};
namespace detail {
struct TransformAttrStorage;
} // namespace detail
class TransformAttr : public ::mlir::Attribute::AttrBase<TransformAttr, ::mlir::Attribute, detail::TransformAttrStorage> {
public:
  using Base::Base;
  using Base::getChecked;
  static TransformAttr get(::mlir::MLIRContext *context, ::mlir::rock::TransformType type, ::llvm::ArrayRef<int64_t> params, ::llvm::ArrayRef<::llvm::StringRef> upperNames, ::llvm::ArrayRef<uint32_t> upperDims, ::llvm::ArrayRef<::llvm::StringRef> lowerNames, ::llvm::ArrayRef<uint32_t> lowerDims);
  static TransformAttr getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ::mlir::rock::TransformType type, ::llvm::ArrayRef<int64_t> params, ::llvm::ArrayRef<::llvm::StringRef> upperNames, ::llvm::ArrayRef<uint32_t> upperDims, ::llvm::ArrayRef<::llvm::StringRef> lowerNames, ::llvm::ArrayRef<uint32_t> lowerDims);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::rock::TransformType type, ::llvm::ArrayRef<int64_t> params, ::llvm::ArrayRef<::llvm::StringRef> upperNames, ::llvm::ArrayRef<uint32_t> upperDims, ::llvm::ArrayRef<::llvm::StringRef> lowerNames, ::llvm::ArrayRef<uint32_t> lowerDims);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"transform"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::rock::TransformType getType() const;
  ::llvm::ArrayRef<int64_t> getParams() const;
  ::llvm::ArrayRef<::llvm::StringRef> getUpperNames() const;
  ::llvm::ArrayRef<uint32_t> getUpperDims() const;
  ::llvm::ArrayRef<::llvm::StringRef> getLowerNames() const;
  ::llvm::ArrayRef<uint32_t> getLowerDims() const;
};
namespace detail {
struct TransformMapAttrStorage;
} // namespace detail
class TransformMapAttr : public ::mlir::Attribute::AttrBase<TransformMapAttr, ::mlir::Attribute, detail::TransformMapAttrStorage> {
public:
  using Base::Base;
  using Base::getChecked;
  static TransformMapAttr get(::mlir::MLIRContext *context, ::llvm::ArrayRef<::mlir::rock::TransformAttr> ops, AffineMapAttr map, DenseI64ArrayAttr upperBounds, DenseI64ArrayAttr lowerBounds);
  static TransformMapAttr getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ::llvm::ArrayRef<::mlir::rock::TransformAttr> ops, AffineMapAttr map, DenseI64ArrayAttr upperBounds, DenseI64ArrayAttr lowerBounds);
  static TransformMapAttr get(ArrayRef<::mlir::rock::TransformAttr> transforms, ArrayRef<int64_t> upperBounds, ArrayRef<int64_t> lowerBounds);
  static TransformMapAttr getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ArrayRef<::mlir::rock::TransformAttr> transforms, ArrayRef<int64_t> upperBounds, ArrayRef<int64_t> lowerBounds);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<::mlir::rock::TransformAttr> ops, AffineMapAttr map, DenseI64ArrayAttr upperBounds, DenseI64ArrayAttr lowerBounds);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"transform_map"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<::mlir::rock::TransformAttr> getOps() const;
  AffineMapAttr getMap() const;
  DenseI64ArrayAttr getUpperBounds() const;
  DenseI64ArrayAttr getLowerBounds() const;
};
namespace detail {
struct WmmaGemmParamsAttrStorage;
} // namespace detail
class WmmaGemmParamsAttr : public ::mlir::Attribute::AttrBase<WmmaGemmParamsAttr, ::mlir::Attribute, detail::WmmaGemmParamsAttrStorage, ::mlir::rock::RockTuningParamAttrInterface::Trait, ::mlir::rock::RockAccelTuningParamAttrInterface::Trait> {
public:
  using Base::Base;
  void getPerfConfigStr(SmallVectorImpl<char> &perfStr) {
      (Twine(getMPerBlock()) + ","
      + Twine(getNPerBlock()) + ","
      + Twine(getKpackPerBlock()) + ","
      + Twine(getMPerWave()) + ","
      + Twine(getNPerWave()) + ","
      + Twine(getKpack()) + ","
      + Twine(getForceUnroll()) + ","
        + "1") /* *ThreadCopyMore* */
      .toVector(perfStr);
  }
  static WmmaGemmParamsAttr get(::mlir::MLIRContext *context, int64_t kpackPerBlock, int64_t mPerBlock, int64_t nPerBlock, int64_t kpack, int64_t mPerWave, int64_t nPerWave, bool forceUnroll);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"wmma_gemm_params"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  int64_t getKpackPerBlock() const;
  int64_t getMPerBlock() const;
  int64_t getNPerBlock() const;
  int64_t getKpack() const;
  int64_t getMPerWave() const;
  int64_t getNPerWave() const;
  bool getForceUnroll() const;
};
namespace detail {
struct XdlopsGemmParamsAttrStorage;
} // namespace detail
class XdlopsGemmParamsAttr : public ::mlir::Attribute::AttrBase<XdlopsGemmParamsAttr, ::mlir::Attribute, detail::XdlopsGemmParamsAttrStorage, ::mlir::rock::RockTuningParamAttrInterface::Trait, ::mlir::rock::RockAccelTuningParamAttrInterface::Trait> {
public:
  using Base::Base;
  void getPerfConfigStr(::llvm::SmallVectorImpl<char> &perfStr) {
      (Twine(getMPerBlock()) + ","
      + Twine(getNPerBlock()) + ","
      + Twine(getKpackPerBlock()) + ","
      + Twine(getMPerWave()) + ","
      + Twine(getNPerWave()) + ","
      + Twine(getKpack()) + ","
      + Twine(getForceUnroll()) + ","
        + "1") /* *ThreadCopyMore* */
      .toVector(perfStr);
  }
  static XdlopsGemmParamsAttr get(::mlir::MLIRContext *context, int64_t kpackPerBlock, int64_t mPerBlock, int64_t nPerBlock, int64_t kpack, int64_t mPerWave, int64_t nPerWave, bool forceUnroll);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"xdlops_gemm_params"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  int64_t getKpackPerBlock() const;
  int64_t getMPerBlock() const;
  int64_t getNPerBlock() const;
  int64_t getKpack() const;
  int64_t getMPerWave() const;
  int64_t getNPerWave() const;
  bool getForceUnroll() const;
};
namespace detail {
struct StoreMethodAttrStorage;
} // namespace detail
class StoreMethodAttr : public ::mlir::Attribute::AttrBase<StoreMethodAttr, ::mlir::Attribute, detail::StoreMethodAttrStorage> {
public:
  using Base::Base;
  static StoreMethodAttr get(::mlir::MLIRContext *context, ::mlir::rock::StoreMethod value);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"StoreMethod"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::rock::StoreMethod getValue() const;
};
} // namespace rock
} // namespace mlir
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::ReduceMethodAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::GemmFeaturesAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::GeneralGemmParamsAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::PrefillAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::TransformAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::TransformMapAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::WmmaGemmParamsAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::XdlopsGemmParamsAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::mlir::rock::StoreMethodAttr)

#endif  // GET_ATTRDEF_CLASSES

