/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_ROCKAFFIXTUNINGPARAMETERSPASS
#define GEN_PASS_DECL_ROCKBLOCKWISEGEMMTOTHREADWISEPASS
#define GEN_PASS_DECL_ROCKBUFFERLOADMERGEPASS
#define GEN_PASS_DECL_ROCKCLEANMATHPASS
#define GEN_PASS_DECL_ROCKCONVTOGEMMPASS
#define GEN_PASS_DECL_ROCKGEMMTOGRIDWISEPASS
#define GEN_PASS_DECL_ROCKGRIDWISEGEMMTOBLOCKWISEPASS
#define GEN_PASS_DECL_ROCKLINALGALIGNPASS
#define GEN_PASS_DECL_ROCKLOOPSTOCFPASS
#define GEN_PASS_DECL_ROCKLOWERREDUCEPASS
#define GEN_PASS_DECL_ROCKPREPARELLVMPASS
#define GEN_PASS_DECL_ROCKREGULARIZEPASS
#define GEN_PASS_DECL_ROCKSUGARTOLOOPSPASS
#define GEN_PASS_DECL_ROCKTHREADWISEGEMMLOWERINGPASS
#define GEN_PASS_DECL_ROCKTRANSFORMTOMEMREFPASS
#define GEN_PASS_DECL_ROCKVIEWTOTRANSFORMPASS
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// RockAffixTuningParametersPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKAFFIXTUNINGPARAMETERSPASS
struct RockAffixTuningParametersPassOptions {
  uint32_t blockSizeOverride = 0;
  uint32_t gridSizeOverride = 0;
  bool fallBackNoConfig = false;
};
std::unique_ptr<::mlir::Pass> createRockAffixTuningParametersPass();
std::unique_ptr<::mlir::Pass> createRockAffixTuningParametersPass(const RockAffixTuningParametersPassOptions &options);
#undef GEN_PASS_DECL_ROCKAFFIXTUNINGPARAMETERSPASS
#endif // GEN_PASS_DECL_ROCKAFFIXTUNINGPARAMETERSPASS
#ifdef GEN_PASS_DEF_ROCKAFFIXTUNINGPARAMETERSPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockAffixTuningParametersPass();
} // namespace impl

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockAffixTuningParametersPass(const RockAffixTuningParametersPassOptions &options);
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockAffixTuningParametersPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockAffixTuningParametersPassBase;

  RockAffixTuningParametersPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockAffixTuningParametersPassBase(const RockAffixTuningParametersPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-affix-params");
  }
  ::llvm::StringRef getArgument() const override { return "rock-affix-params"; }

  ::llvm::StringRef getDescription() const override { return "populate tuning parameters for gemm and convolution ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockAffixTuningParametersPass");
  }
  ::llvm::StringRef getName() const override { return "RockAffixTuningParametersPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<func::FuncDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockAffixTuningParametersPassBase<DerivedT>)

  RockAffixTuningParametersPassBase(const RockAffixTuningParametersPassOptions &options) : RockAffixTuningParametersPassBase() {
    blockSizeOverride = options.blockSizeOverride;
    gridSizeOverride = options.gridSizeOverride;
    fallBackNoConfig = options.fallBackNoConfig;
  }
protected:
  ::mlir::Pass::Option<uint32_t> blockSizeOverride{*this, "block_size", ::llvm::cl::desc("Non-zero values fixes a particular block size"), ::llvm::cl::init(0)};
  ::mlir::Pass::Option<uint32_t> gridSizeOverride{*this, "grid_size", ::llvm::cl::desc("Non-zero value fixes a particular grid size"), ::llvm::cl::init(0)};
  ::mlir::Pass::Option<bool> fallBackNoConfig{*this, "fallback", ::llvm::cl::desc("Fall back to a heuristic system when hand-specified tuning parameters are invalid"), ::llvm::cl::init(false)};
private:

  friend std::unique_ptr<::mlir::Pass> createRockAffixTuningParametersPass() {
    return std::make_unique<DerivedT>();
  }

  friend std::unique_ptr<::mlir::Pass> createRockAffixTuningParametersPass(const RockAffixTuningParametersPassOptions &options) {
    return std::make_unique<DerivedT>(options);
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockAffixTuningParametersPass() {
  return impl::createRockAffixTuningParametersPass();
}

std::unique_ptr<::mlir::Pass> createRockAffixTuningParametersPass(const RockAffixTuningParametersPassOptions &options) {
  return impl::createRockAffixTuningParametersPass(options);
}
#undef GEN_PASS_DEF_ROCKAFFIXTUNINGPARAMETERSPASS
#endif // GEN_PASS_DEF_ROCKAFFIXTUNINGPARAMETERSPASS

//===----------------------------------------------------------------------===//
// RockBlockwiseGemmToThreadwisePass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKBLOCKWISEGEMMTOTHREADWISEPASS
std::unique_ptr<::mlir::Pass> createRockBlockwiseGemmToThreadwisePass();
#undef GEN_PASS_DECL_ROCKBLOCKWISEGEMMTOTHREADWISEPASS
#endif // GEN_PASS_DECL_ROCKBLOCKWISEGEMMTOTHREADWISEPASS
#ifdef GEN_PASS_DEF_ROCKBLOCKWISEGEMMTOTHREADWISEPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockBlockwiseGemmToThreadwisePass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockBlockwiseGemmToThreadwisePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockBlockwiseGemmToThreadwisePassBase;

  RockBlockwiseGemmToThreadwisePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockBlockwiseGemmToThreadwisePassBase(const RockBlockwiseGemmToThreadwisePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-blockwise-gemm-to-threadwise");
  }
  ::llvm::StringRef getArgument() const override { return "rock-blockwise-gemm-to-threadwise"; }

  ::llvm::StringRef getDescription() const override { return "Expand blockwise gemm into threadwise gemm and clean up fusion-related shorthand"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockBlockwiseGemmToThreadwisePass");
  }
  ::llvm::StringRef getName() const override { return "RockBlockwiseGemmToThreadwisePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<scf::SCFDialect>();

  registry.insert<vector::VectorDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockBlockwiseGemmToThreadwisePassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockBlockwiseGemmToThreadwisePass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockBlockwiseGemmToThreadwisePass() {
  return impl::createRockBlockwiseGemmToThreadwisePass();
}
#undef GEN_PASS_DEF_ROCKBLOCKWISEGEMMTOTHREADWISEPASS
#endif // GEN_PASS_DEF_ROCKBLOCKWISEGEMMTOTHREADWISEPASS

//===----------------------------------------------------------------------===//
// RockBufferLoadMergePass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKBUFFERLOADMERGEPASS
std::unique_ptr<::mlir::Pass> createRockBufferLoadMergePass();
#undef GEN_PASS_DECL_ROCKBUFFERLOADMERGEPASS
#endif // GEN_PASS_DECL_ROCKBUFFERLOADMERGEPASS
#ifdef GEN_PASS_DEF_ROCKBUFFERLOADMERGEPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockBufferLoadMergePass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockBufferLoadMergePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockBufferLoadMergePassBase;

  RockBufferLoadMergePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockBufferLoadMergePassBase(const RockBufferLoadMergePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-buffer-load-merge");
  }
  ::llvm::StringRef getArgument() const override { return "rock-buffer-load-merge"; }

  ::llvm::StringRef getDescription() const override { return "Merge identical memory loads to buffers only read. Assumes noalias."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockBufferLoadMergePass");
  }
  ::llvm::StringRef getName() const override { return "RockBufferLoadMergePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<::mlir::amdgpu::AMDGPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockBufferLoadMergePassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockBufferLoadMergePass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockBufferLoadMergePass() {
  return impl::createRockBufferLoadMergePass();
}
#undef GEN_PASS_DEF_ROCKBUFFERLOADMERGEPASS
#endif // GEN_PASS_DEF_ROCKBUFFERLOADMERGEPASS

//===----------------------------------------------------------------------===//
// RockCleanMathPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKCLEANMATHPASS
std::unique_ptr<::mlir::Pass> createRockCleanMathPass();
#undef GEN_PASS_DECL_ROCKCLEANMATHPASS
#endif // GEN_PASS_DECL_ROCKCLEANMATHPASS
#ifdef GEN_PASS_DEF_ROCKCLEANMATHPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockCleanMathPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockCleanMathPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockCleanMathPassBase;

  RockCleanMathPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockCleanMathPassBase(const RockCleanMathPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-clean-math");
  }
  ::llvm::StringRef getArgument() const override { return "rock-clean-math"; }

  ::llvm::StringRef getDescription() const override { return "Clean up math using integer range analysis and other MLIR passes"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockCleanMathPass");
  }
  ::llvm::StringRef getName() const override { return "RockCleanMathPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockCleanMathPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockCleanMathPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockCleanMathPass() {
  return impl::createRockCleanMathPass();
}
#undef GEN_PASS_DEF_ROCKCLEANMATHPASS
#endif // GEN_PASS_DEF_ROCKCLEANMATHPASS

//===----------------------------------------------------------------------===//
// RockConvToGemmPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKCONVTOGEMMPASS
std::unique_ptr<::mlir::Pass> createRockConvToGemmPass();
#undef GEN_PASS_DECL_ROCKCONVTOGEMMPASS
#endif // GEN_PASS_DECL_ROCKCONVTOGEMMPASS
#ifdef GEN_PASS_DEF_ROCKCONVTOGEMMPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockConvToGemmPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockConvToGemmPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockConvToGemmPassBase;

  RockConvToGemmPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockConvToGemmPassBase(const RockConvToGemmPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-conv-to-gemm");
  }
  ::llvm::StringRef getArgument() const override { return "rock-conv-to-gemm"; }

  ::llvm::StringRef getDescription() const override { return "expand convolution into coordinate transformations and gemm"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockConvToGemmPass");
  }
  ::llvm::StringRef getName() const override { return "RockConvToGemmPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<arith::ArithDialect>();

  registry.insert<scf::SCFDialect>();

  registry.insert<gpu::GPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockConvToGemmPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockConvToGemmPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockConvToGemmPass() {
  return impl::createRockConvToGemmPass();
}
#undef GEN_PASS_DEF_ROCKCONVTOGEMMPASS
#endif // GEN_PASS_DEF_ROCKCONVTOGEMMPASS

//===----------------------------------------------------------------------===//
// RockGemmToGridwisePass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKGEMMTOGRIDWISEPASS
std::unique_ptr<::mlir::Pass> createRockGemmToGridwisePass();
#undef GEN_PASS_DECL_ROCKGEMMTOGRIDWISEPASS
#endif // GEN_PASS_DECL_ROCKGEMMTOGRIDWISEPASS
#ifdef GEN_PASS_DEF_ROCKGEMMTOGRIDWISEPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockGemmToGridwisePass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockGemmToGridwisePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockGemmToGridwisePassBase;

  RockGemmToGridwisePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockGemmToGridwisePassBase(const RockGemmToGridwisePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-gemm-to-gridwise");
  }
  ::llvm::StringRef getArgument() const override { return "rock-gemm-to-gridwise"; }

  ::llvm::StringRef getDescription() const override { return "convert gemm to gridwise gemm, adding padding"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockGemmToGridwisePass");
  }
  ::llvm::StringRef getName() const override { return "RockGemmToGridwisePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<func::FuncDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockGemmToGridwisePassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockGemmToGridwisePass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockGemmToGridwisePass() {
  return impl::createRockGemmToGridwisePass();
}
#undef GEN_PASS_DEF_ROCKGEMMTOGRIDWISEPASS
#endif // GEN_PASS_DEF_ROCKGEMMTOGRIDWISEPASS

//===----------------------------------------------------------------------===//
// RockGridwiseGemmToBlockwisePass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKGRIDWISEGEMMTOBLOCKWISEPASS
std::unique_ptr<::mlir::Pass> createRockGridwiseGemmToBlockwisePass();
#undef GEN_PASS_DECL_ROCKGRIDWISEGEMMTOBLOCKWISEPASS
#endif // GEN_PASS_DECL_ROCKGRIDWISEGEMMTOBLOCKWISEPASS
#ifdef GEN_PASS_DEF_ROCKGRIDWISEGEMMTOBLOCKWISEPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockGridwiseGemmToBlockwisePass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockGridwiseGemmToBlockwisePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockGridwiseGemmToBlockwisePassBase;

  RockGridwiseGemmToBlockwisePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockGridwiseGemmToBlockwisePassBase(const RockGridwiseGemmToBlockwisePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-gridwise-gemm-to-blockwise");
  }
  ::llvm::StringRef getArgument() const override { return "rock-gridwise-gemm-to-blockwise"; }

  ::llvm::StringRef getDescription() const override { return "expand gridwise gemm into blockwise copy, blockwise gemm, and threadwise copy"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockGridwiseGemmToBlockwisePass");
  }
  ::llvm::StringRef getName() const override { return "RockGridwiseGemmToBlockwisePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<linalg::LinalgDialect>();

  registry.insert<scf::SCFDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockGridwiseGemmToBlockwisePassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockGridwiseGemmToBlockwisePass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockGridwiseGemmToBlockwisePass() {
  return impl::createRockGridwiseGemmToBlockwisePass();
}
#undef GEN_PASS_DEF_ROCKGRIDWISEGEMMTOBLOCKWISEPASS
#endif // GEN_PASS_DEF_ROCKGRIDWISEGEMMTOBLOCKWISEPASS

//===----------------------------------------------------------------------===//
// RockLinalgAlignPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKLINALGALIGNPASS
std::unique_ptr<::mlir::Pass> createRockLinalgAlignPass();
#undef GEN_PASS_DECL_ROCKLINALGALIGNPASS
#endif // GEN_PASS_DECL_ROCKLINALGALIGNPASS
#ifdef GEN_PASS_DEF_ROCKLINALGALIGNPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockLinalgAlignPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockLinalgAlignPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockLinalgAlignPassBase;

  RockLinalgAlignPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockLinalgAlignPassBase(const RockLinalgAlignPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-linalg-align");
  }
  ::llvm::StringRef getArgument() const override { return "rock-linalg-align"; }

  ::llvm::StringRef getDescription() const override { return "expand linalg ops aligned with threadwise copy"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockLinalgAlignPass");
  }
  ::llvm::StringRef getName() const override { return "RockLinalgAlignPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<linalg::LinalgDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<gpu::GPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockLinalgAlignPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockLinalgAlignPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockLinalgAlignPass() {
  return impl::createRockLinalgAlignPass();
}
#undef GEN_PASS_DEF_ROCKLINALGALIGNPASS
#endif // GEN_PASS_DEF_ROCKLINALGALIGNPASS

//===----------------------------------------------------------------------===//
// RockLoopsToCfPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKLOOPSTOCFPASS
std::unique_ptr<::mlir::Pass> createRockLoopsToCfPass();
#undef GEN_PASS_DECL_ROCKLOOPSTOCFPASS
#endif // GEN_PASS_DECL_ROCKLOOPSTOCFPASS
#ifdef GEN_PASS_DEF_ROCKLOOPSTOCFPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockLoopsToCfPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockLoopsToCfPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockLoopsToCfPassBase;

  RockLoopsToCfPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockLoopsToCfPassBase(const RockLoopsToCfPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-loops-to-cf");
  }
  ::llvm::StringRef getArgument() const override { return "rock-loops-to-cf"; }

  ::llvm::StringRef getDescription() const override { return "expand loop / affine dialects to control flow. Notice GPU dialect will explicitly NOT be used in this pass"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockLoopsToCfPass");
  }
  ::llvm::StringRef getName() const override { return "RockLoopsToCfPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<scf::SCFDialect>();

  registry.insert<cf::ControlFlowDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockLoopsToCfPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockLoopsToCfPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockLoopsToCfPass() {
  return impl::createRockLoopsToCfPass();
}
#undef GEN_PASS_DEF_ROCKLOOPSTOCFPASS
#endif // GEN_PASS_DEF_ROCKLOOPSTOCFPASS

//===----------------------------------------------------------------------===//
// RockLowerReducePass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKLOWERREDUCEPASS
std::unique_ptr<::mlir::Pass> createRockLowerReducePass();
#undef GEN_PASS_DECL_ROCKLOWERREDUCEPASS
#endif // GEN_PASS_DECL_ROCKLOWERREDUCEPASS
#ifdef GEN_PASS_DEF_ROCKLOWERREDUCEPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockLowerReducePass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockLowerReducePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockLowerReducePassBase;

  RockLowerReducePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockLowerReducePassBase(const RockLowerReducePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-lower-reduce");
  }
  ::llvm::StringRef getArgument() const override { return "rock-lower-reduce"; }

  ::llvm::StringRef getDescription() const override { return "Lower rock.reduce operator"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockLowerReducePass");
  }
  ::llvm::StringRef getName() const override { return "RockLowerReducePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<func::FuncDialect>();

  registry.insert<gpu::GPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockLowerReducePassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockLowerReducePass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockLowerReducePass() {
  return impl::createRockLowerReducePass();
}
#undef GEN_PASS_DEF_ROCKLOWERREDUCEPASS
#endif // GEN_PASS_DEF_ROCKLOWERREDUCEPASS

//===----------------------------------------------------------------------===//
// RockPrepareLLVMPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKPREPARELLVMPASS
std::unique_ptr<::mlir::Pass> createRockPrepareLLVMPass();
#undef GEN_PASS_DECL_ROCKPREPARELLVMPASS
#endif // GEN_PASS_DECL_ROCKPREPARELLVMPASS
#ifdef GEN_PASS_DEF_ROCKPREPARELLVMPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockPrepareLLVMPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockPrepareLLVMPassBase : public ::mlir::OperationPass<> {
public:
  using Base = RockPrepareLLVMPassBase;

  RockPrepareLLVMPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  RockPrepareLLVMPassBase(const RockPrepareLLVMPassBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-prepare-llvm");
  }
  ::llvm::StringRef getArgument() const override { return "rock-prepare-llvm"; }

  ::llvm::StringRef getDescription() const override { return "prepare the generated code for llvm"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockPrepareLLVMPass");
  }
  ::llvm::StringRef getName() const override { return "RockPrepareLLVMPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockPrepareLLVMPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockPrepareLLVMPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockPrepareLLVMPass() {
  return impl::createRockPrepareLLVMPass();
}
#undef GEN_PASS_DEF_ROCKPREPARELLVMPASS
#endif // GEN_PASS_DEF_ROCKPREPARELLVMPASS

//===----------------------------------------------------------------------===//
// RockRegularizePass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKREGULARIZEPASS
std::unique_ptr<::mlir::Pass> createRockRegularizePass();
#undef GEN_PASS_DECL_ROCKREGULARIZEPASS
#endif // GEN_PASS_DECL_ROCKREGULARIZEPASS
#ifdef GEN_PASS_DEF_ROCKREGULARIZEPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockRegularizePass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockRegularizePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockRegularizePassBase;

  RockRegularizePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockRegularizePassBase(const RockRegularizePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-regularize");
  }
  ::llvm::StringRef getArgument() const override { return "rock-regularize"; }

  ::llvm::StringRef getDescription() const override { return "convert linalg.generic to regular form to enable fusion with convolution and GEMM"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockRegularizePass");
  }
  ::llvm::StringRef getName() const override { return "RockRegularizePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<linalg::LinalgDialect>();

  registry.insert<memref::MemRefDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockRegularizePassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockRegularizePass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockRegularizePass() {
  return impl::createRockRegularizePass();
}
#undef GEN_PASS_DEF_ROCKREGULARIZEPASS
#endif // GEN_PASS_DEF_ROCKREGULARIZEPASS

//===----------------------------------------------------------------------===//
// RockSugarToLoopsPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKSUGARTOLOOPSPASS
std::unique_ptr<::mlir::Pass> createRockSugarToLoopsPass();
#undef GEN_PASS_DECL_ROCKSUGARTOLOOPSPASS
#endif // GEN_PASS_DECL_ROCKSUGARTOLOOPSPASS
#ifdef GEN_PASS_DEF_ROCKSUGARTOLOOPSPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockSugarToLoopsPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockSugarToLoopsPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockSugarToLoopsPassBase;

  RockSugarToLoopsPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockSugarToLoopsPassBase(const RockSugarToLoopsPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-sugar-to-loops");
  }
  ::llvm::StringRef getArgument() const override { return "rock-sugar-to-loops"; }

  ::llvm::StringRef getDescription() const override { return "Expand shorthand, like transforming_for and extract_slice, to other dialects"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockSugarToLoopsPass");
  }
  ::llvm::StringRef getName() const override { return "RockSugarToLoopsPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<arith::ArithDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<amdgpu::AMDGPUDialect>();

  registry.insert<LLVM::LLVMDialect>();

  registry.insert<scf::SCFDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockSugarToLoopsPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockSugarToLoopsPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockSugarToLoopsPass() {
  return impl::createRockSugarToLoopsPass();
}
#undef GEN_PASS_DEF_ROCKSUGARTOLOOPSPASS
#endif // GEN_PASS_DEF_ROCKSUGARTOLOOPSPASS

//===----------------------------------------------------------------------===//
// RockThreadwiseGemmLoweringPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKTHREADWISEGEMMLOWERINGPASS
std::unique_ptr<::mlir::Pass> createRockThreadwiseGemmLoweringPass();
#undef GEN_PASS_DECL_ROCKTHREADWISEGEMMLOWERINGPASS
#endif // GEN_PASS_DECL_ROCKTHREADWISEGEMMLOWERINGPASS
#ifdef GEN_PASS_DEF_ROCKTHREADWISEGEMMLOWERINGPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockThreadwiseGemmLoweringPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockThreadwiseGemmLoweringPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockThreadwiseGemmLoweringPassBase;

  RockThreadwiseGemmLoweringPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockThreadwiseGemmLoweringPassBase(const RockThreadwiseGemmLoweringPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-threadwise-gemm-lowering");
  }
  ::llvm::StringRef getArgument() const override { return "rock-threadwise-gemm-lowering"; }

  ::llvm::StringRef getDescription() const override { return "expand threadwise gemm to final implementation."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockThreadwiseGemmLoweringPass");
  }
  ::llvm::StringRef getName() const override { return "RockThreadwiseGemmLoweringPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<gpu::GPUDialect>();

  registry.insert<rock::RockDialect>();

  registry.insert<amdgpu::AMDGPUDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<memref::MemRefDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockThreadwiseGemmLoweringPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockThreadwiseGemmLoweringPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockThreadwiseGemmLoweringPass() {
  return impl::createRockThreadwiseGemmLoweringPass();
}
#undef GEN_PASS_DEF_ROCKTHREADWISEGEMMLOWERINGPASS
#endif // GEN_PASS_DEF_ROCKTHREADWISEGEMMLOWERINGPASS

//===----------------------------------------------------------------------===//
// RockTransformToMemrefPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKTRANSFORMTOMEMREFPASS
std::unique_ptr<::mlir::Pass> createRockTransformToMemrefPass();
#undef GEN_PASS_DECL_ROCKTRANSFORMTOMEMREFPASS
#endif // GEN_PASS_DECL_ROCKTRANSFORMTOMEMREFPASS
#ifdef GEN_PASS_DEF_ROCKTRANSFORMTOMEMREFPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockTransformToMemrefPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockTransformToMemrefPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockTransformToMemrefPassBase;

  RockTransformToMemrefPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockTransformToMemrefPassBase(const RockTransformToMemrefPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-transform-to-memref");
  }
  ::llvm::StringRef getArgument() const override { return "rock-transform-to-memref"; }

  ::llvm::StringRef getDescription() const override { return "convert remaining rock.transform ops to memref.expand/collapse_shape"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockTransformToMemrefPass");
  }
  ::llvm::StringRef getName() const override { return "RockTransformToMemrefPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<memref::MemRefDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockTransformToMemrefPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockTransformToMemrefPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockTransformToMemrefPass() {
  return impl::createRockTransformToMemrefPass();
}
#undef GEN_PASS_DEF_ROCKTRANSFORMTOMEMREFPASS
#endif // GEN_PASS_DEF_ROCKTRANSFORMTOMEMREFPASS

//===----------------------------------------------------------------------===//
// RockViewToTransformPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCKVIEWTOTRANSFORMPASS
std::unique_ptr<::mlir::Pass> createRockViewToTransformPass();
#undef GEN_PASS_DECL_ROCKVIEWTOTRANSFORMPASS
#endif // GEN_PASS_DECL_ROCKVIEWTOTRANSFORMPASS
#ifdef GEN_PASS_DEF_ROCKVIEWTOTRANSFORMPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRockViewToTransformPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RockViewToTransformPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockViewToTransformPassBase;

  RockViewToTransformPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockViewToTransformPassBase(const RockViewToTransformPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-view-to-transform");
  }
  ::llvm::StringRef getArgument() const override { return "rock-view-to-transform"; }

  ::llvm::StringRef getDescription() const override { return "convert tensor view ops to rock.transform"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockViewToTransformPass");
  }
  ::llvm::StringRef getName() const override { return "RockViewToTransformPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<tensor::TensorDialect>();

  registry.insert<tosa::TosaDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockViewToTransformPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRockViewToTransformPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRockViewToTransformPass() {
  return impl::createRockViewToTransformPass();
}
#undef GEN_PASS_DEF_ROCKVIEWTOTRANSFORMPASS
#endif // GEN_PASS_DEF_ROCKVIEWTOTRANSFORMPASS
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// RockAffixTuningParametersPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockAffixTuningParametersPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockAffixTuningParametersPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockAffixTuningParametersPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockAffixTuningParametersPass();
  });
}

//===----------------------------------------------------------------------===//
// RockBlockwiseGemmToThreadwisePass Registration
//===----------------------------------------------------------------------===//

inline void registerRockBlockwiseGemmToThreadwisePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockBlockwiseGemmToThreadwisePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockBlockwiseGemmToThreadwisePassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockBlockwiseGemmToThreadwisePass();
  });
}

//===----------------------------------------------------------------------===//
// RockBufferLoadMergePass Registration
//===----------------------------------------------------------------------===//

inline void registerRockBufferLoadMergePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockBufferLoadMergePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockBufferLoadMergePassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockBufferLoadMergePass();
  });
}

//===----------------------------------------------------------------------===//
// RockCleanMathPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockCleanMathPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockCleanMathPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockCleanMathPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockCleanMathPass();
  });
}

//===----------------------------------------------------------------------===//
// RockConvToGemmPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockConvToGemmPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockConvToGemmPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockConvToGemmPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockConvToGemmPass();
  });
}

//===----------------------------------------------------------------------===//
// RockGemmToGridwisePass Registration
//===----------------------------------------------------------------------===//

inline void registerRockGemmToGridwisePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockGemmToGridwisePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockGemmToGridwisePassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockGemmToGridwisePass();
  });
}

//===----------------------------------------------------------------------===//
// RockGridwiseGemmToBlockwisePass Registration
//===----------------------------------------------------------------------===//

inline void registerRockGridwiseGemmToBlockwisePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockGridwiseGemmToBlockwisePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockGridwiseGemmToBlockwisePassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockGridwiseGemmToBlockwisePass();
  });
}

//===----------------------------------------------------------------------===//
// RockLinalgAlignPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockLinalgAlignPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockLinalgAlignPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockLinalgAlignPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockLinalgAlignPass();
  });
}

//===----------------------------------------------------------------------===//
// RockLoopsToCfPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockLoopsToCfPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockLoopsToCfPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockLoopsToCfPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockLoopsToCfPass();
  });
}

//===----------------------------------------------------------------------===//
// RockLowerReducePass Registration
//===----------------------------------------------------------------------===//

inline void registerRockLowerReducePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockLowerReducePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockLowerReducePassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockLowerReducePass();
  });
}

//===----------------------------------------------------------------------===//
// RockPrepareLLVMPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockPrepareLLVMPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockPrepareLLVMPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockPrepareLLVMPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockPrepareLLVMPass();
  });
}

//===----------------------------------------------------------------------===//
// RockRegularizePass Registration
//===----------------------------------------------------------------------===//

inline void registerRockRegularizePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockRegularizePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockRegularizePassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockRegularizePass();
  });
}

//===----------------------------------------------------------------------===//
// RockSugarToLoopsPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockSugarToLoopsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockSugarToLoopsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockSugarToLoopsPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockSugarToLoopsPass();
  });
}

//===----------------------------------------------------------------------===//
// RockThreadwiseGemmLoweringPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockThreadwiseGemmLoweringPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockThreadwiseGemmLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockThreadwiseGemmLoweringPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockThreadwiseGemmLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
// RockTransformToMemrefPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockTransformToMemrefPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockTransformToMemrefPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockTransformToMemrefPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockTransformToMemrefPass();
  });
}

//===----------------------------------------------------------------------===//
// RockViewToTransformPass Registration
//===----------------------------------------------------------------------===//

inline void registerRockViewToTransformPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockViewToTransformPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRockViewToTransformPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRockViewToTransformPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerRockAffixTuningParametersPass();
  registerRockBlockwiseGemmToThreadwisePass();
  registerRockBufferLoadMergePass();
  registerRockCleanMathPass();
  registerRockConvToGemmPass();
  registerRockGemmToGridwisePass();
  registerRockGridwiseGemmToBlockwisePass();
  registerRockLinalgAlignPass();
  registerRockLoopsToCfPass();
  registerRockLowerReducePass();
  registerRockPrepareLLVMPass();
  registerRockRegularizePass();
  registerRockSugarToLoopsPass();
  registerRockThreadwiseGemmLoweringPass();
  registerRockTransformToMemrefPass();
  registerRockViewToTransformPass();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class RockAffixTuningParametersPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockAffixTuningParametersPassBase;

  RockAffixTuningParametersPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockAffixTuningParametersPassBase(const RockAffixTuningParametersPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-affix-params");
  }
  ::llvm::StringRef getArgument() const override { return "rock-affix-params"; }

  ::llvm::StringRef getDescription() const override { return "populate tuning parameters for gemm and convolution ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockAffixTuningParametersPass");
  }
  ::llvm::StringRef getName() const override { return "RockAffixTuningParametersPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<func::FuncDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockAffixTuningParametersPassBase<DerivedT>)

protected:
  ::mlir::Pass::Option<uint32_t> blockSizeOverride{*this, "block_size", ::llvm::cl::desc("Non-zero values fixes a particular block size"), ::llvm::cl::init(0)};
  ::mlir::Pass::Option<uint32_t> gridSizeOverride{*this, "grid_size", ::llvm::cl::desc("Non-zero value fixes a particular grid size"), ::llvm::cl::init(0)};
  ::mlir::Pass::Option<bool> fallBackNoConfig{*this, "fallback", ::llvm::cl::desc("Fall back to a heuristic system when hand-specified tuning parameters are invalid"), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class RockBlockwiseGemmToThreadwisePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockBlockwiseGemmToThreadwisePassBase;

  RockBlockwiseGemmToThreadwisePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockBlockwiseGemmToThreadwisePassBase(const RockBlockwiseGemmToThreadwisePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-blockwise-gemm-to-threadwise");
  }
  ::llvm::StringRef getArgument() const override { return "rock-blockwise-gemm-to-threadwise"; }

  ::llvm::StringRef getDescription() const override { return "Expand blockwise gemm into threadwise gemm and clean up fusion-related shorthand"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockBlockwiseGemmToThreadwisePass");
  }
  ::llvm::StringRef getName() const override { return "RockBlockwiseGemmToThreadwisePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<scf::SCFDialect>();

  registry.insert<vector::VectorDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockBlockwiseGemmToThreadwisePassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockBufferLoadMergePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockBufferLoadMergePassBase;

  RockBufferLoadMergePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockBufferLoadMergePassBase(const RockBufferLoadMergePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-buffer-load-merge");
  }
  ::llvm::StringRef getArgument() const override { return "rock-buffer-load-merge"; }

  ::llvm::StringRef getDescription() const override { return "Merge identical memory loads to buffers only read. Assumes noalias."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockBufferLoadMergePass");
  }
  ::llvm::StringRef getName() const override { return "RockBufferLoadMergePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<::mlir::amdgpu::AMDGPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockBufferLoadMergePassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockCleanMathPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockCleanMathPassBase;

  RockCleanMathPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockCleanMathPassBase(const RockCleanMathPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-clean-math");
  }
  ::llvm::StringRef getArgument() const override { return "rock-clean-math"; }

  ::llvm::StringRef getDescription() const override { return "Clean up math using integer range analysis and other MLIR passes"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockCleanMathPass");
  }
  ::llvm::StringRef getName() const override { return "RockCleanMathPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockCleanMathPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockConvToGemmPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockConvToGemmPassBase;

  RockConvToGemmPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockConvToGemmPassBase(const RockConvToGemmPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-conv-to-gemm");
  }
  ::llvm::StringRef getArgument() const override { return "rock-conv-to-gemm"; }

  ::llvm::StringRef getDescription() const override { return "expand convolution into coordinate transformations and gemm"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockConvToGemmPass");
  }
  ::llvm::StringRef getName() const override { return "RockConvToGemmPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<arith::ArithDialect>();

  registry.insert<scf::SCFDialect>();

  registry.insert<gpu::GPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockConvToGemmPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockGemmToGridwisePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockGemmToGridwisePassBase;

  RockGemmToGridwisePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockGemmToGridwisePassBase(const RockGemmToGridwisePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-gemm-to-gridwise");
  }
  ::llvm::StringRef getArgument() const override { return "rock-gemm-to-gridwise"; }

  ::llvm::StringRef getDescription() const override { return "convert gemm to gridwise gemm, adding padding"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockGemmToGridwisePass");
  }
  ::llvm::StringRef getName() const override { return "RockGemmToGridwisePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<func::FuncDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockGemmToGridwisePassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockGridwiseGemmToBlockwisePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockGridwiseGemmToBlockwisePassBase;

  RockGridwiseGemmToBlockwisePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockGridwiseGemmToBlockwisePassBase(const RockGridwiseGemmToBlockwisePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-gridwise-gemm-to-blockwise");
  }
  ::llvm::StringRef getArgument() const override { return "rock-gridwise-gemm-to-blockwise"; }

  ::llvm::StringRef getDescription() const override { return "expand gridwise gemm into blockwise copy, blockwise gemm, and threadwise copy"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockGridwiseGemmToBlockwisePass");
  }
  ::llvm::StringRef getName() const override { return "RockGridwiseGemmToBlockwisePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<linalg::LinalgDialect>();

  registry.insert<scf::SCFDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockGridwiseGemmToBlockwisePassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockLinalgAlignPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockLinalgAlignPassBase;

  RockLinalgAlignPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockLinalgAlignPassBase(const RockLinalgAlignPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-linalg-align");
  }
  ::llvm::StringRef getArgument() const override { return "rock-linalg-align"; }

  ::llvm::StringRef getDescription() const override { return "expand linalg ops aligned with threadwise copy"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockLinalgAlignPass");
  }
  ::llvm::StringRef getName() const override { return "RockLinalgAlignPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<linalg::LinalgDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<gpu::GPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockLinalgAlignPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockLoopsToCfPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockLoopsToCfPassBase;

  RockLoopsToCfPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockLoopsToCfPassBase(const RockLoopsToCfPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-loops-to-cf");
  }
  ::llvm::StringRef getArgument() const override { return "rock-loops-to-cf"; }

  ::llvm::StringRef getDescription() const override { return "expand loop / affine dialects to control flow. Notice GPU dialect will explicitly NOT be used in this pass"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockLoopsToCfPass");
  }
  ::llvm::StringRef getName() const override { return "RockLoopsToCfPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<scf::SCFDialect>();

  registry.insert<cf::ControlFlowDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockLoopsToCfPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockLowerReducePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockLowerReducePassBase;

  RockLowerReducePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockLowerReducePassBase(const RockLowerReducePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-lower-reduce");
  }
  ::llvm::StringRef getArgument() const override { return "rock-lower-reduce"; }

  ::llvm::StringRef getDescription() const override { return "Lower rock.reduce operator"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockLowerReducePass");
  }
  ::llvm::StringRef getName() const override { return "RockLowerReducePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<func::FuncDialect>();

  registry.insert<gpu::GPUDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockLowerReducePassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockPrepareLLVMPassBase : public ::mlir::OperationPass<> {
public:
  using Base = RockPrepareLLVMPassBase;

  RockPrepareLLVMPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  RockPrepareLLVMPassBase(const RockPrepareLLVMPassBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-prepare-llvm");
  }
  ::llvm::StringRef getArgument() const override { return "rock-prepare-llvm"; }

  ::llvm::StringRef getDescription() const override { return "prepare the generated code for llvm"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockPrepareLLVMPass");
  }
  ::llvm::StringRef getName() const override { return "RockPrepareLLVMPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockPrepareLLVMPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockRegularizePassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockRegularizePassBase;

  RockRegularizePassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockRegularizePassBase(const RockRegularizePassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-regularize");
  }
  ::llvm::StringRef getArgument() const override { return "rock-regularize"; }

  ::llvm::StringRef getDescription() const override { return "convert linalg.generic to regular form to enable fusion with convolution and GEMM"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockRegularizePass");
  }
  ::llvm::StringRef getName() const override { return "RockRegularizePass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<linalg::LinalgDialect>();

  registry.insert<memref::MemRefDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockRegularizePassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockSugarToLoopsPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockSugarToLoopsPassBase;

  RockSugarToLoopsPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockSugarToLoopsPassBase(const RockSugarToLoopsPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-sugar-to-loops");
  }
  ::llvm::StringRef getArgument() const override { return "rock-sugar-to-loops"; }

  ::llvm::StringRef getDescription() const override { return "Expand shorthand, like transforming_for and extract_slice, to other dialects"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockSugarToLoopsPass");
  }
  ::llvm::StringRef getName() const override { return "RockSugarToLoopsPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<arith::ArithDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<memref::MemRefDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<amdgpu::AMDGPUDialect>();

  registry.insert<LLVM::LLVMDialect>();

  registry.insert<scf::SCFDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockSugarToLoopsPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockThreadwiseGemmLoweringPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockThreadwiseGemmLoweringPassBase;

  RockThreadwiseGemmLoweringPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockThreadwiseGemmLoweringPassBase(const RockThreadwiseGemmLoweringPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-threadwise-gemm-lowering");
  }
  ::llvm::StringRef getArgument() const override { return "rock-threadwise-gemm-lowering"; }

  ::llvm::StringRef getDescription() const override { return "expand threadwise gemm to final implementation."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockThreadwiseGemmLoweringPass");
  }
  ::llvm::StringRef getName() const override { return "RockThreadwiseGemmLoweringPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<gpu::GPUDialect>();

  registry.insert<rock::RockDialect>();

  registry.insert<amdgpu::AMDGPUDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<memref::MemRefDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockThreadwiseGemmLoweringPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockTransformToMemrefPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockTransformToMemrefPassBase;

  RockTransformToMemrefPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockTransformToMemrefPassBase(const RockTransformToMemrefPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-transform-to-memref");
  }
  ::llvm::StringRef getArgument() const override { return "rock-transform-to-memref"; }

  ::llvm::StringRef getDescription() const override { return "convert remaining rock.transform ops to memref.expand/collapse_shape"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockTransformToMemrefPass");
  }
  ::llvm::StringRef getName() const override { return "RockTransformToMemrefPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<affine::AffineDialect>();

  registry.insert<gpu::GPUDialect>();

  registry.insert<vector::VectorDialect>();

  registry.insert<memref::MemRefDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockTransformToMemrefPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RockViewToTransformPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = RockViewToTransformPassBase;

  RockViewToTransformPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  RockViewToTransformPassBase(const RockViewToTransformPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rock-view-to-transform");
  }
  ::llvm::StringRef getArgument() const override { return "rock-view-to-transform"; }

  ::llvm::StringRef getDescription() const override { return "convert tensor view ops to rock.transform"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RockViewToTransformPass");
  }
  ::llvm::StringRef getName() const override { return "RockViewToTransformPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<rock::RockDialect>();

  registry.insert<tensor::TensorDialect>();

  registry.insert<tosa::TosaDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RockViewToTransformPassBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
