/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Definitions                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

/// Clone the current call-like operation with the given attributes but
/// re-assign operands and result-types. Used in bufferization for result
/// buffers.
Operation *mlir::CallOpInterface::clone(OpBuilder & b, Location loc, TypeRange resultTypes, ValueRange operands) {
      return getImpl()->clone(getImpl(), getOperation(), b, loc, resultTypes, operands);
  }
/// Returns the callee of this call-like operation. A `callee` is either a
/// reference to a symbol, via SymbolRefAttr, or a reference to a defined
/// SSA value. If the reference is an SSA value, the SSA value corresponds
/// to a region of a lambda-like operation.
::mlir::CallInterfaceCallable mlir::CallOpInterface::getCallableForCallee() {
      return getImpl()->getCallableForCallee(getImpl(), getOperation());
  }
/// Sets the callee of this call-like operation. A `callee` is either a
/// reference to a symbol, via SymbolRefAttr, or a reference to a defined
/// SSA value. The type of the `callee` is expected to be the same as the
/// return type of `getCallableForCallee`, e.g., `callee` should be
/// SymbolRefAttr for `func.call`.
void mlir::CallOpInterface::setCalleeFromCallable(::mlir::CallInterfaceCallable callee) {
      return getImpl()->setCalleeFromCallable(getImpl(), getOperation(), callee);
  }
/// Returns the operands within this call that are used as arguments to the
/// callee.
::mlir::Operation::operand_range mlir::CallOpInterface::getArgOperands() {
      return getImpl()->getArgOperands(getImpl(), getOperation());
  }
/// Returns the results for this call that are returned by the callee.
::mlir::Operation::result_range mlir::CallOpInterface::getCallResults() {
      return getImpl()->getCallResults(getImpl(), getOperation());
  }
/// Returns the result types for this call that are returned by the callee.
::mlir::Operation::result_type_range mlir::CallOpInterface::getCallResultTypes() {
      return getImpl()->getCallResultTypes(getImpl(), getOperation());
  }
/// Update the operand_segment_sizes attribute for changes to operands.
void mlir::CallOpInterface::updateSegmentSizes(::mlir::MLIRContext * context) {
      return getImpl()->updateSegmentSizes(getImpl(), getOperation(), context);
  }
/// Returns the region on the current operation that is callable. This may
/// return null in the case of an external callable object, e.g. an external
/// function.
::mlir::Region *mlir::CallableOpInterface::getCallableRegion() {
      return getImpl()->getCallableRegion(getImpl(), getOperation());
  }
/// Returns the results types that the callable region produces when
/// executed.
::llvm::ArrayRef<::mlir::Type> mlir::CallableOpInterface::getCallableResults() {
      return getImpl()->getCallableResults(getImpl(), getOperation());
  }
/// Returns the argument attributes for all callable region arguments or
/// null if there are none.
::mlir::ArrayAttr mlir::CallableOpInterface::getCallableArgAttrs() {
      return getImpl()->getCallableArgAttrs(getImpl(), getOperation());
  }
/// Returns the result attributes for all callable region results or null
/// if there are none.
::mlir::ArrayAttr mlir::CallableOpInterface::getCallableResAttrs() {
      return getImpl()->getCallableResAttrs(getImpl(), getOperation());
  }
