/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
class CallOpInterface;
namespace detail {
struct CallOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    Operation *(*clone)(const Concept *impl, ::mlir::Operation *, OpBuilder &, Location, TypeRange, ValueRange);
    ::mlir::CallInterfaceCallable (*getCallableForCallee)(const Concept *impl, ::mlir::Operation *);
    void (*setCalleeFromCallable)(const Concept *impl, ::mlir::Operation *, ::mlir::CallInterfaceCallable);
    ::mlir::Operation::operand_range (*getArgOperands)(const Concept *impl, ::mlir::Operation *);
    ::mlir::Operation::result_range (*getCallResults)(const Concept *impl, ::mlir::Operation *);
    ::mlir::Operation::result_type_range (*getCallResultTypes)(const Concept *impl, ::mlir::Operation *);
    void (*updateSegmentSizes)(const Concept *impl, ::mlir::Operation *, ::mlir::MLIRContext *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::CallOpInterface;
    Model() : Concept{clone, getCallableForCallee, setCalleeFromCallable, getArgOperands, getCallResults, getCallResultTypes, updateSegmentSizes} {}

    static inline Operation *clone(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpBuilder & b, Location loc, TypeRange resultTypes, ValueRange operands);
    static inline ::mlir::CallInterfaceCallable getCallableForCallee(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void setCalleeFromCallable(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::CallInterfaceCallable callee);
    static inline ::mlir::Operation::operand_range getArgOperands(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::Operation::result_range getCallResults(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::Operation::result_type_range getCallResultTypes(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void updateSegmentSizes(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::MLIRContext * context);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::CallOpInterface;
    FallbackModel() : Concept{clone, getCallableForCallee, setCalleeFromCallable, getArgOperands, getCallResults, getCallResultTypes, updateSegmentSizes} {}

    static inline Operation *clone(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpBuilder & b, Location loc, TypeRange resultTypes, ValueRange operands);
    static inline ::mlir::CallInterfaceCallable getCallableForCallee(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void setCalleeFromCallable(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::CallInterfaceCallable callee);
    static inline ::mlir::Operation::operand_range getArgOperands(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::Operation::result_range getCallResults(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::Operation::result_type_range getCallResultTypes(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline void updateSegmentSizes(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::MLIRContext * context);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    ::mlir::Operation::result_range getCallResults(::mlir::Operation *tablegen_opaque_val) const;
    ::mlir::Operation::result_type_range getCallResultTypes(::mlir::Operation *tablegen_opaque_val) const;
    void updateSegmentSizes(::mlir::Operation *tablegen_opaque_val, ::mlir::MLIRContext *context) const;
  };
};template <typename ConcreteOp>
struct CallOpInterfaceTrait;

} // namespace detail
class CallOpInterface : public ::mlir::OpInterface<CallOpInterface, detail::CallOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<CallOpInterface, detail::CallOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::CallOpInterfaceTrait<ConcreteOp> {};
  /// Clone the current call-like operation with the given attributes but
  /// re-assign operands and result-types. Used in bufferization for result
  /// buffers.
  Operation *clone(OpBuilder & b, Location loc, TypeRange resultTypes, ValueRange operands);
  /// Returns the callee of this call-like operation. A `callee` is either a
  /// reference to a symbol, via SymbolRefAttr, or a reference to a defined
  /// SSA value. If the reference is an SSA value, the SSA value corresponds
  /// to a region of a lambda-like operation.
  ::mlir::CallInterfaceCallable getCallableForCallee();
  /// Sets the callee of this call-like operation. A `callee` is either a
  /// reference to a symbol, via SymbolRefAttr, or a reference to a defined
  /// SSA value. The type of the `callee` is expected to be the same as the
  /// return type of `getCallableForCallee`, e.g., `callee` should be
  /// SymbolRefAttr for `func.call`.
  void setCalleeFromCallable(::mlir::CallInterfaceCallable callee);
  /// Returns the operands within this call that are used as arguments to the
  /// callee.
  ::mlir::Operation::operand_range getArgOperands();
  /// Returns the results for this call that are returned by the callee.
  ::mlir::Operation::result_range getCallResults();
  /// Returns the result types for this call that are returned by the callee.
  ::mlir::Operation::result_type_range getCallResultTypes();
  /// Update the operand_segment_sizes attribute for changes to operands.
  void updateSegmentSizes(::mlir::MLIRContext * context);

    /// Resolve the callable operation for given callee to a
    /// CallableOpInterface, or nullptr if a valid callable was not resolved.
    /// `symbolTable` is an optional parameter that will allow for using a
    /// cached symbol table for symbol lookups instead of performing an O(N)
    /// scan.
    Operation *resolveCallable(SymbolTableCollection *symbolTable = nullptr);
};
namespace detail {
  template <typename ConcreteOp>
  struct CallOpInterfaceTrait : public ::mlir::OpInterface<CallOpInterface, detail::CallOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    /// Returns the results for this call that are returned by the callee.
    ::mlir::Operation::result_range getCallResults() {
      return (*static_cast<ConcreteOp *>(this))->getResults();
    }
    /// Returns the result types for this call that are returned by the callee.
    ::mlir::Operation::result_type_range getCallResultTypes() {
      return (*static_cast<ConcreteOp *>(this))->getResultTypes();
    }
    /// Update the operand_segment_sizes attribute for changes to operands.
    void updateSegmentSizes(::mlir::MLIRContext * context) {
      assert(!(*static_cast<ConcreteOp *>(this))->hasAttr("operand_segment_sizes") &&
               !(*static_cast<ConcreteOp *>(this))->hasAttr("result_segment_sizes"));
    }
  };
}// namespace detail
} // namespace mlir
namespace mlir {
class CallableOpInterface;
namespace detail {
struct CallableOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    ::mlir::Region *(*getCallableRegion)(const Concept *impl, ::mlir::Operation *);
    ::llvm::ArrayRef<::mlir::Type> (*getCallableResults)(const Concept *impl, ::mlir::Operation *);
    ::mlir::ArrayAttr (*getCallableArgAttrs)(const Concept *impl, ::mlir::Operation *);
    ::mlir::ArrayAttr (*getCallableResAttrs)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::CallableOpInterface;
    Model() : Concept{getCallableRegion, getCallableResults, getCallableArgAttrs, getCallableResAttrs} {}

    static inline ::mlir::Region *getCallableRegion(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::llvm::ArrayRef<::mlir::Type> getCallableResults(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::ArrayAttr getCallableArgAttrs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::ArrayAttr getCallableResAttrs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::CallableOpInterface;
    FallbackModel() : Concept{getCallableRegion, getCallableResults, getCallableArgAttrs, getCallableResAttrs} {}

    static inline ::mlir::Region *getCallableRegion(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::llvm::ArrayRef<::mlir::Type> getCallableResults(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::ArrayAttr getCallableArgAttrs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::ArrayAttr getCallableResAttrs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};template <typename ConcreteOp>
struct CallableOpInterfaceTrait;

} // namespace detail
class CallableOpInterface : public ::mlir::OpInterface<CallableOpInterface, detail::CallableOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<CallableOpInterface, detail::CallableOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::CallableOpInterfaceTrait<ConcreteOp> {};
  /// Returns the region on the current operation that is callable. This may
  /// return null in the case of an external callable object, e.g. an external
  /// function.
  ::mlir::Region *getCallableRegion();
  /// Returns the results types that the callable region produces when
  /// executed.
  ::llvm::ArrayRef<::mlir::Type> getCallableResults();
  /// Returns the argument attributes for all callable region arguments or
  /// null if there are none.
  ::mlir::ArrayAttr getCallableArgAttrs();
  /// Returns the result attributes for all callable region results or null
  /// if there are none.
  ::mlir::ArrayAttr getCallableResAttrs();
};
namespace detail {
  template <typename ConcreteOp>
  struct CallableOpInterfaceTrait : public ::mlir::OpInterface<CallableOpInterface, detail::CallableOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace mlir
namespace mlir {
template<typename ConcreteOp>
Operation *detail::CallOpInterfaceInterfaceTraits::Model<ConcreteOp>::clone(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpBuilder & b, Location loc, TypeRange resultTypes, ValueRange operands) {
  IRMapping bvm;
        OperationState state(
          loc, ConcreteOp::getOperationName(), operands, resultTypes,
          (llvm::cast<ConcreteOp>(tablegen_opaque_val))->getAttrs());
        auto op = b.create(state);
        CallOpInterface callIF(op);
        callIF.updateSegmentSizes(b.getContext());
        return op;
}
template<typename ConcreteOp>
::mlir::CallInterfaceCallable detail::CallOpInterfaceInterfaceTraits::Model<ConcreteOp>::getCallableForCallee(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getCallableForCallee();
}
template<typename ConcreteOp>
void detail::CallOpInterfaceInterfaceTraits::Model<ConcreteOp>::setCalleeFromCallable(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::CallInterfaceCallable callee) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).setCalleeFromCallable(callee);
}
template<typename ConcreteOp>
::mlir::Operation::operand_range detail::CallOpInterfaceInterfaceTraits::Model<ConcreteOp>::getArgOperands(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getArgOperands();
}
template<typename ConcreteOp>
::mlir::Operation::result_range detail::CallOpInterfaceInterfaceTraits::Model<ConcreteOp>::getCallResults(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getCallResults();
}
template<typename ConcreteOp>
::mlir::Operation::result_type_range detail::CallOpInterfaceInterfaceTraits::Model<ConcreteOp>::getCallResultTypes(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getCallResultTypes();
}
template<typename ConcreteOp>
void detail::CallOpInterfaceInterfaceTraits::Model<ConcreteOp>::updateSegmentSizes(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::MLIRContext * context) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).updateSegmentSizes(context);
}
template<typename ConcreteOp>
Operation *detail::CallOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::clone(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpBuilder & b, Location loc, TypeRange resultTypes, ValueRange operands) {
  return static_cast<const ConcreteOp *>(impl)->clone(tablegen_opaque_val, b, loc, resultTypes, operands);
}
template<typename ConcreteOp>
::mlir::CallInterfaceCallable detail::CallOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getCallableForCallee(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getCallableForCallee(tablegen_opaque_val);
}
template<typename ConcreteOp>
void detail::CallOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::setCalleeFromCallable(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::CallInterfaceCallable callee) {
  return static_cast<const ConcreteOp *>(impl)->setCalleeFromCallable(tablegen_opaque_val, callee);
}
template<typename ConcreteOp>
::mlir::Operation::operand_range detail::CallOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getArgOperands(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getArgOperands(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::Operation::result_range detail::CallOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getCallResults(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getCallResults(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::Operation::result_type_range detail::CallOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getCallResultTypes(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getCallResultTypes(tablegen_opaque_val);
}
template<typename ConcreteOp>
void detail::CallOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::updateSegmentSizes(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::mlir::MLIRContext * context) {
  return static_cast<const ConcreteOp *>(impl)->updateSegmentSizes(tablegen_opaque_val, context);
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::Operation::result_range detail::CallOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getCallResults(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val))->getResults();
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::Operation::result_type_range detail::CallOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getCallResultTypes(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val))->getResultTypes();
}
template<typename ConcreteModel, typename ConcreteOp>
void detail::CallOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::updateSegmentSizes(::mlir::Operation *tablegen_opaque_val, ::mlir::MLIRContext *context) const {
assert(!(llvm::cast<ConcreteOp>(tablegen_opaque_val))->hasAttr("operand_segment_sizes") &&
               !(llvm::cast<ConcreteOp>(tablegen_opaque_val))->hasAttr("result_segment_sizes"));
}
} // namespace mlir
namespace mlir {
template<typename ConcreteOp>
::mlir::Region *detail::CallableOpInterfaceInterfaceTraits::Model<ConcreteOp>::getCallableRegion(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getCallableRegion();
}
template<typename ConcreteOp>
::llvm::ArrayRef<::mlir::Type> detail::CallableOpInterfaceInterfaceTraits::Model<ConcreteOp>::getCallableResults(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getCallableResults();
}
template<typename ConcreteOp>
::mlir::ArrayAttr detail::CallableOpInterfaceInterfaceTraits::Model<ConcreteOp>::getCallableArgAttrs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getCallableArgAttrs();
}
template<typename ConcreteOp>
::mlir::ArrayAttr detail::CallableOpInterfaceInterfaceTraits::Model<ConcreteOp>::getCallableResAttrs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getCallableResAttrs();
}
template<typename ConcreteOp>
::mlir::Region *detail::CallableOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getCallableRegion(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getCallableRegion(tablegen_opaque_val);
}
template<typename ConcreteOp>
::llvm::ArrayRef<::mlir::Type> detail::CallableOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getCallableResults(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getCallableResults(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::ArrayAttr detail::CallableOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getCallableArgAttrs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getCallableArgAttrs(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::ArrayAttr detail::CallableOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getCallableResAttrs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getCallableResAttrs(tablegen_opaque_val);
}
} // namespace mlir
